LoRom

!RAMAddr = $3200	;If you get any errors with tilemaps or palettes when pausing, using XRAY, or during some boss rooms, it is likely because of this address.

!PaletteLine = $1000
!SelectPalette = $0000
!WarnPalette = $0C00
	
;Sound libraries are just JSL addresses. Library 1 is 809049. Library 2 is 8090CB. Library 3 is 80914D
!HUDSelectSFX = #$0037
	!HUDSelectSL = $809049
!BeamSelectSFX = #$0037
	!BeamSelectSL = $809049
!BeamToHUDSFX = #$0037
	!BeamToHUDSL = $809049
!HUDToBeamSFX = #$0037
	!HUDToBeamSL = $809049


!Blank = $200F		;Tile data for blank / filled tile
!Empty = $000E		;Tile data for clear / transparent tile

!ETFull = $203F
!ETEmpty = $204F

!HUD1 = $2000		;Tile data for "1"
!HUD2 = $2001		;Tile data for "2"
!HUD3 = $2002		;Tile data for "3"
!HUD4 = $2003		;Tile data for "4"
!HUD5 = $2004		;Tile data for "5"
!HUD6 = $2005		;Tile data for "6"
!HUD7 = $2006		;Tile data for "7"
!HUD8 = $2007		;Tile data for "8"
!HUD9 = $2008		;Tile data for "9"
!HUD0 = $2009		;Tile data for "0"
!EBar0 = $2018
!EBar1 = $2017
!EBar2 = $2016
!EBar3 = $2015
!EBar4 = $2014
!EBar5 = $2013
!EBar6 = $2012
!EBar7 = $2011
!EBar8 = $2010
!CBar0 = $2028
!CBar1 = $2027
!CBar2 = $2026
!CBar3 = $2025
!CBar4 = $2024
!CBar5 = $2023
!CBar6 = $2022
!CBar7 = $2021
!CBar8 = $2020

;Don't change $FFFB-$FFFF. These are instruction flags

org $87D000

BasicHUD:
	DW $2019, !Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,$201D,$201D,$201D,$201D,$201D,$201C
	DW $2028, $203D, $2030, $2031, $603D, $203B, !Empty,!Empty,!Empty,!Empty,!Empty,$200A, $200B, $200C, $200D, !Empty,$603B, !Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,$201F,$201F,$201F,$201F,$201F,$201E
	DW $2028, $A03D, $2040, $2041, $E03D, $203C, !Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,$603C, !Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,$201F,$201F,$201F,$201F,$201F,$201E
	DW $2029, !Empty,!Empty,!Empty,!Empty,$203D, !EBar0,!EBar0,!EBar0,!EBar0,!EBar0,!EBar0,!EBar0,!EBar0,!EBar0,!EBar0,$603D, !Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,!Empty,$201F,$201F,$201F,$201F,$201F,$201E
	DW $FFFF
BeamTypeTable:
	DW WaveBeamHUD,IceBeamHUD,SpazerBeamHUD,PowerBeamHUD,PlasmaBeamHUD,PowerBeamHUD,PowerBeamHUD,PowerBeamHUD
HUDTypeTable:
	DW MissileIconHUD,SuperIconHUD,PowerIconHUD,GrappleIconHUD,VisorIconHUD
PowerBeamHUD:		;Tilemap for power beam
	DW $203E,$2030,$6030,$603E
	DW $FFFB,$0008
	DW $A03E,$2040,$6040,$E03E
	DW $FFFF
WaveBeamHUD:		;Tilemap for wave beam
	DW $203E,$2031,$E041,$603E
	DW $FFFB,$0008
	DW $A03E,$2041,$E031,$E03E
	DW $FFFF
IceBeamHUD:			;Tilemap for ice beam
	DW $203E,$2032,$6032,$603E
	DW $FFFB,$0008
	DW $A03E,$2042,$6042,$E03E
	DW $FFFF
SpazerBeamHUD:		;Tilemap for spazer beam
	DW $203E,$2033,$6033,$603E
	DW $FFFB,$0008
	DW $A03E,$2043,$6043,$E03E
	DW $FFFF
PlasmaBeamHUD:		;Tilemap for plasma beam
	DW $203E,$2034,$6034,$603E
	DW $FFFB,$0008
	DW $A03E,$2044,$6044,$E03E
	DW $FFFF
HyperBeamHUD:		;Tilemap for hyper beam
	DW $203E,$2035,$6035,$603E
	DW $FFFB,$0008
	DW $A03E,$2045,$6045,$E03E
	DW $FFFF
MissileIconHUD:
	DW $203E,$2036,$6036,$603E
	DW $FFFB,$0008
	DW $A03E,$2046,$6046,$E03E
	DW $FFFF
SuperIconHUD:
	DW $203E,$2037,$6037,$603E
	DW $FFFB,$0008
	DW $A03E,$2047,$6047,$E03E
	DW $FFFF
PowerIconHUD:
	DW $203E,$2038,$6038,$603E
	DW $FFFB,$0008
	DW $A03E,$2048,$6048,$E03E
	DW $FFFF
GrappleIconHUD:
	DW $203E,$2039,$6039,$603E
	DW $FFFB,$0008
	DW $A03E,$2049,$6049,$E03E
	DW $FFFF
VisorIconHUD:
	DW $203E,$203A,$603A,$603E
	DW $FFFB,$0008
	DW $A03E,$204A,$604A,$E03E
	DW $FFFF

MissileHUD:			;Tilemap for missiles
	DW $204B,$FFFF
SuperHUD:			;Tilemap for super missiles
	DW $204C,$FFFF
PowerHUD:			;Tilemap for power bombs
	DW $204D,$FFFF

ETPosition:
	DW $009E,$009C,$009A,$0098,$0096,$0094,$0092,$0090,$008E,$008C
NumberTileMaps:
	DW !HUD0,!HUD1,!HUD2,!HUD3,!HUD4,!HUD5,!HUD6,!HUD7,!HUD8,!HUD9
BarTileMaps:
	DW !EBar0,!EBar1,!EBar2,!EBar3,!EBar4,!EBar4,!EBar5,!EBar6,!EBar7,!EBar8		;Extras because there needs to be 10 indexes
CBarTileMaps:
	DW !CBar1,!CBar2,!CBar3,!CBar4,!CBar5,!CBar6,!CBar7,!CBar8
MainHUDRoutine: PHP : PHB : PHK : PLB : PHX : PHY : REP #$30
	JSR DrawBasicHUD
	JSR DrawEnergyTanks : JSR EnergyAlertFlash
		JSR GetHUDInput : JSR HUDIconCheck
	JSR HUDEquipment : JSR BeamEquipment : JSR ChargeBar
	LDX $0330
		LDA #$0100 : STA $D0,X : INX #2
		LDA #!RAMAddr : STA $D0,X : INX #2
		LDA #$7E7E : STA $D0,X : INX
		LDA #$5800 : STA $D0,X : INX #2
HUDMinimap:
		LDA #$000A : STA $D0,X : INX #2
		LDA #$C63C : STA $D0,X : INX #2
		LDA #$7E7E : STA $D0,X : INX
		LDA #$583A : STA $D0,X : INX #2
		LDA #$000A : STA $D0,X : INX #2
		LDA #$C67C : STA $D0,X : INX #2
		LDA #$7E7E : STA $D0,X : INX
		LDA #$585A : STA $D0,X : INX #2
		LDA #$000A : STA $D0,X : INX #2
		LDA #$C6BC : STA $D0,X : INX #2
		LDA #$7E7E : STA $D0,X : INX
		LDA #$587A : STA $D0,X : INX #2
	STX $0330
		PLY : PLX : PLB : PLP : RTL
DrawBasicHUD:
	LDA #!PaletteLine : STA $18
		LDX #!RAMAddr : LDY #BasicHUD : JSR SetTileMap
	RTS
HUDIconCheck:
	LDA $09D2 : BNE ++
	LDA $09C8 : BEQ +
		LDA #$0100 : BRA ++
+	LDA $09CC : BEQ +
		LDA #$0200 : BRA ++
+	LDA $09D0 : BEQ +
		LDA #$0300 : BRA ++
+	LDA $09A2 : BIT #$4000 : BEQ +
		LDA #$0400 : BRA ++
+	LDA $09CA : BIT #$8000 : BEQ ++
		LDA #$0500 : ++ : TSB $09D2 : RTS
	
GetHUDInput:
	LDA $0A76 : BEQ +
		LDA #$0008 : STA $09A6 : LDA $09D2 : AND #$0F00 : STA $09D2 : RTS	
+	LDA #$0004 : STA $02
		LDA $8F : BIT $09BA : BNE HUDPressSelect : BIT $09B8 : BNE HUDPressCancel : RTS
	HUDPressSelect:
		LDA $09D2 : BEQ $05 : AND #$000F : BEQ ++ : STA $00 : ASL A : TAX : JSR (HUDSelectTable,X)
			CMP $00 : BEQ + : STA $00 : XBA : ORA $00 : STA $09D2
			JSR CheckCurrentSounds : LDA !HUDSelectSFX : JSL !HUDSelectSL : RTS
		+	RTS
	++	SEP #$20 : LDA $09D3 : STA $09D2 : REP #$20
		JSR CheckCurrentSounds : LDA !BeamToHUDSFX : JSL !BeamToHUDSL : RTS
	HUDPressCancel:
		LDA $09D2 : AND #$000F : BNE ++
		LDA $09A6 : AND #$000F : STA $00 : ASL A : TAX : JSR (BeamSelectTable,X)
			CMP $00 : BEQ + : STA $00 : LDA $09A6 : AND #$FFF0 : ORA $00 : STA $09A6
			JSL $90AC8D : JSR CheckCurrentSounds : LDA !BeamSelectSFX : JSL !BeamSelectSL : RTS
		+	RTS
	++	LDA $09D2 : AND #$0F00 : STA $09D2
		JSR CheckCurrentSounds : LDA !HUDToBeamSFX : JSL !HUDToBeamSL : RTS
	HUDSelectTable:
		DW CheckMissileAmmoInput
		DW CheckSuperAmmoInput
		DW CheckPowerAmmoInput
		DW CheckGrappleInput
		DW CheckXRayInput
		DW CheckMissileAmmoInput
	CheckMissileAmmoInput: LDA $09C6 : BEQ $04 : LDA #$0001 : RTS
		DEC $02 : BMI EndHUDSelect
	CheckSuperAmmoInput: LDA $09CA : BEQ $04 : LDA #$0002 : RTS
		DEC $02 : BMI EndHUDSelect
	CheckPowerAmmoInput: LDA $09CE : BEQ $04 : LDA #$0003 : RTS
		DEC $02 : BMI EndHUDSelect
	CheckGrappleInput: LDA $09A4 : BIT #$4000 : BEQ $04 : LDA #$0004 : RTS
		DEC $02 : BMI EndHUDSelect
	CheckXRayInput: LDA $09A4 : BIT #$8000 : BEQ $04 : LDA #$0005 : RTS
		DEC $02 : BMI EndHUDSelect : BRA CheckMissileAmmoInput
	EndHUDSelect: PLA : STZ $09D2 : RTS
	BeamSelectTable:
		DW PowerBeamInput
		DW WaveBeamInput
		DW IceBeamInput
		DW PowerBeamInput
		DW SpazerBeamInput
		DW PowerBeamInput
		DW PowerBeamInput
		DW PowerBeamInput
		DW PlasmaBeamInput
		DW PowerBeamInput		;These aren't really needed, but are here just in case the player somehow mixed beams.
		DW PowerBeamInput
		DW PowerBeamInput
	PowerBeamInput: LDA $09A8 : BIT #$0002 : BEQ IceBeamInput : LDA $0998 : CMP #$000F : BNE + : JSR CancelIceII
	+	LDA #$0002 : RTS
	IceBeamInput: LDA $09A8 : BIT #$0001 : BEQ WaveBeamInput : LDA $0998 : CMP #$000F : BNE + : JSR CancelWaveII
	+	LDA #$0001 : RTS
	WaveBeamInput: LDA $09A8 : BIT #$0004 : BEQ SpazerBeamInput : LDA $0998 : CMP #$000F : BNE + : JSR CancelSpazerII 
	+	LDA #$0004 : RTS
	SpazerBeamInput: LDA $09A8 : BIT #$0008 : BEQ PlasmaBeamInput : LDA $0998 : CMP #$000F : BNE + : JSR CancelPlasmaII
	+	LDA #$0008 : RTS
	PlasmaBeamInput: LDA $0998 : CMP #$000F : BNE + : JSR CancelAllII
	+	LDA #$0000 : RTS
CheckCurrentSounds:
	LDA $0CD0 : BEQ + : LDA #$0001 : STA $0CD0 : STZ $0CD6 : JSL $91DEBA
+	LDA $0A1F : AND #$00FF : CMP #$0003 : BEQ + : CMP #$0014 : BEQ +
	LDA $0D32 : CMP #$C4F0 : BNE + : LDA $0A78 : BNE + : RTS
+	PLA : RTS
DrawEnergyTanks:
	LDY #!PaletteLine : STY $18
	LDA $09C2 : JSR CalcEnergy : STA $14 : LDA $4216 : STA $12
	LDA $09C4 : JSR CalcEnergy : INC A : STA $16
	LDY #$0012
	DrawNextETank:	
		DEC $16 : BEQ NoMoreETanks : LDX #!ETEmpty
		LDA $14 : BEQ EmptyETank : DEC $14 : LDX #!ETFull
	EmptyETank:
		TXA : ORA $18 : LDX ETPosition,Y : STA $7E0000+#!RAMAddr,X
		DEY : DEY : BPL DrawNextETank
	NoMoreETanks:
		LDX #!RAMAddr+#$4E : LDA $12 : JSR DrawNumbers : LDA $12 : JSR DrawEnergyBar : RTS
DrawEnergyBar:
	STA $4204 : SEP #$20 : LDA #$0A : STA $4206 : PHA : PLA : PHA : PLA : REP #$20
	LDA $4214 : STA $12
		LDX #!RAMAddr+#$CC
		NextBarSection: DEC $12 : BPL FullBarSection
		LDA $4216 : ASL A : TAY : LDA BarTileMaps,Y : ORA $18 : STA $7E0000,X : RTS
		FullBarSection: LDA #!EBar8 : ORA $18 : STA $7E0000,X : INX #2 : BRA NextBarSection
CalcEnergy:
	STA $4204 : SEP #$20 : LDA #$64 : STA $4206
	PHA : PLA : PHA : PLA : REP #$20 : LDA $4214 : RTS
EnergyAlertFlash:
	LDA $09C2 : CMP #$001F : BCS +
	LDA $05B5 : AND #$0008 : BNE + : LDY #!WarnPalette : STY $18
	LDY #$0009 : LDX #$000C+#!RAMAddr : JSR PaletteAlertShift
	LDY #$0009 : LDX #$004C+#!RAMAddr : JSR PaletteAlertShift
	LDY #$0009 : LDX #$008C+#!RAMAddr : JSR PaletteAlertShift
	LDY #$0009 : LDX #$00CC+#!RAMAddr : JSR PaletteAlertShift
+	RTS
	PaletteAlertShift:
	-	LDA $7E0000,X : AND #$E3FF : ORA $18 : STA $7E0000,X : INX #2 : DEY : BPL - : RTS
HUDEquipment:
	LDY #!PaletteLine
	LDA $09C8 : BEQ + : LDA $09D2 : AND #$000F : CMP #$0001 : BNE $03 : LDY #!SelectPalette
		LDA $09C6 : BNE $03 : LDY #!WarnPalette : STY $18
		LDX #!RAMAddr+#$6A : LDY #MissileHUD : JSR SetTileMap : LDA $09C6 : JSR DrawNumbers
+	LDY #!PaletteLine
	LDA $09CC : BEQ + : LDA $09D2 : AND #$000F : CMP #$0002 : BNE $03 : LDY #!SelectPalette
		LDA $09CA : BNE $03 : LDY #!WarnPalette : STY $18
		LDX #!RAMAddr+#$AA : LDY #SuperHUD : JSR SetTileMap : LDA $09CA : JSR DrawNumbers
+	LDY #!PaletteLine
	LDA $09D0 : BEQ + : LDA $09D2 : AND #$000F : CMP #$0003 : BNE $03 : LDY #!SelectPalette
		LDA $09CE : BNE $03 : LDY #!WarnPalette : STY $18
		LDX #!RAMAddr+#$EA : LDY #PowerHUD : JSR SetTileMap : LDA $09CE : JSR DrawNumbers

+	LDY #!SelectPalette
		LDA $09D2 : AND #$000F : CMP #$0000 : BNE +
	LDY #!PaletteLine
		LDA $09D2 : XBA : AND #$000F : CMP #$0000 : BNE +
			RTS
+	STY $18 : DEC A : ASL A : TAY : LDA HUDTypeTable,Y : TAY
		LDX #!RAMAddr+#$62 : JSR SetTileMap
++	RTS
BeamEquipment:
	LDY #!PaletteLine : LDA $09D2 : AND #$000F : BNE $03 : LDY #!SelectPalette : STY $18
	LDX #!RAMAddr+#$42 
	LDA $0A76 : BEQ +
		LDY #HyperBeamHUD : JSR SetTileMap : RTS
+	LDA $09A6 : AND #$000F : BNE +
		LDY #PowerBeamHUD : JSR SetTileMap : RTS
+	AND #$000E : TAY : LDA BeamTypeTable,Y : TAY
		JSR SetTileMap : RTS

ChargeBar:
	LDY #!PaletteLine
	LDA $09A6 : BIT #$1000 : BNE +
		LDA #!Empty : STA $7E0000+#!RAMAddr : STA $7E0040+#!RAMAddr : STA $7E0080+#!RAMAddr : STA $7E00C0+#!RAMAddr : RTS
+	LDA $0CD0 : CMP #$0010 : BCS + : RTS
+		SBC #$0010 : CMP #$003C : BCC $06 : LDY #!SelectPalette : LDA #$003C : LSR #2
		STA $4204 : SEP #$20 : LDA #$08 : STA $4206 : PHA : PLA : PHA : PLA : REP #$20
		LDA $4214 : STA $12
	STY $18 : LDX #!RAMAddr+#$80
		NextCBarSection: DEC $12 : BPL FullCBarSection
		LDA $4216 : ASL A : TAY : LDA CBarTileMaps,Y : ORA $18 : STA $7E0000,X : RTS
		FullCBarSection: LDA #!CBar8 : ORA $18 : STA $7E0000,X : LDX #!RAMAddr+#$40 : BRA NextCBarSection

DrawNumbers:
	STA $4204 : SEP #$20 : LDA #$0A : STA $4206 : PHA : PLA : PHA : PLA : REP #$20
	LDA $4214 : ASL A : TAY : LDA NumberTileMaps,Y : ORA $18 : STA $7E0000,X
	LDA $4216 : ASL A : TAY : LDA NumberTileMaps,Y : ORA $18 : STA $7E0002,X : RTS
SetTileMap:
	LDA $0000,Y : AND #$FFF0 : CMP #$FFF0 : BEQ RunTileMapInst
	SetNextTileMap: LDA $0000,Y : ORA $18 : STA $7E0000,X : INY #2 : INX #2 : BRA SetTileMap : RTS
	RunTileMapInst: LDA $0000,Y : EOR #$FFFF : ASL A : PHX : TAX : JSR (TileMapInstTable,X) : PLX : INY #2 : BRA SetNextTileMap
	TileMapInstTable:
		DW EndTileMapInst,NewLineInst,TileMapSpaceInst,TileMapNewAddress,NewLineSubInst
	EndTileMapInst: PLA : PLX : RTS
	NewLineInst: LDA $03,S : CLC : ADC #$0040 : STA $03,S : RTS
	TileMapSpaceInst: LDA $03,S : CLC : ADC #$0002 : STA $03,S : RTS
	TileMapNewAddress: INY #2 : LDA $0000,Y : STA $03,S : RTS
	NewLineSubInst: LDA $03,S : CLC : ADC #$0040 : SEC : SBC $0002,Y : STA $03,S : INY #2 : RTS
	
BeamSelect:
	PHP : REP #$30
	LDA $24 : EOR #$FFFF : AND $09A6
	BIT #$0001 : BNE CancelWave
	BIT #$0002 : BNE CancelIce
	BIT #$0004 : BNE CancelSpazer
	BIT #$0008 : BNE CancelPlasma
EndBeamSelect:
	PEA $8282 : PLB : PEA $AFD8 : RTL
CancelWave: JSR CancelWaveII : BRA EndBeamSelect
CancelIce: JSR CancelIceII : BRA EndBeamSelect
CancelSpazer: JSR CancelSpazerII : BRA EndBeamSelect
CancelPlasma: JSR CancelPlasmaII : BRA EndBeamSelect
CancelWaveII:		;These routines NEED two "layers" because the first layer uses some stack manipulation to call routines from another bank.
	LDA $09A6 : AND #$1001 : STA $09A6
		LDA #$0C00 : STA $12
	LDA #$3C48 : JSR UpdateGFX
	LDA #$3CC8 : JSR UpdateGFX
	LDA #$3D08 : JSR UpdateGFX
		LDA #$0800 : STA $12
	LDA #$3C88 : JSR UpdateGFX : RTS
CancelIceII:
	LDA $09A6 : AND #$1002 : STA $09A6
		LDA #$0C00 : STA $12
	LDA #$3C88 : JSR UpdateGFX
	LDA #$3CC8 : JSR UpdateGFX
	LDA #$3D08 : JSR UpdateGFX
		LDA #$0800 : STA $12
	LDA #$3C48 : JSR UpdateGFX : RTS
CancelSpazerII:
	LDA $09A6 : AND #$1004 : STA $09A6
		LDA #$0C00 : STA $12
	LDA #$3C48 : JSR UpdateGFX
	LDA #$3C88 : JSR UpdateGFX
	LDA #$3D08 : JSR UpdateGFX
		LDA #$0800 : STA $12
	LDA #$3CC8 : JSR UpdateGFX : RTS
CancelPlasmaII:
	LDA $09A6 : AND #$1008 : STA $09A6
		LDA #$0C00 : STA $12
	LDA #$3C48 : JSR UpdateGFX
	LDA #$3C88 : JSR UpdateGFX
	LDA #$3DC8 : JSR UpdateGFX
		LDA #$0800 : STA $12
	LDA #$3D08 : JSR UpdateGFX : RTS
CancelAllII:
	LDA $09A6 : AND #$1000 : STA $09A6
		LDA #$0C00 : STA $12
	LDA #$3C48 : JSR UpdateGFX
	LDA #$3C88 : JSR UpdateGFX
	LDA #$3DC8 : JSR UpdateGFX
	LDA #$3D08 : JSR UpdateGFX : RTS
UpdateGFX:
	STA $00 : LDA #$000A : STA $16
	PHK : PER $FFFF+#EndUpdateGFX : PEA $8A20 : JMP $82A29D
EndUpdateGFX:
	RTS
Pickup:
	PHP : PHA : PHY	
	LDA $09A6 : AND #$F000 : ORA $0000,Y : STA $09A6
	ORA $09A8 : STA $09A8
	PLY : PLA : PLP : RTL

org $828063		;When game is loading
	JSL MainHUDRoutine
org $828BA0		;When game is running
	JSL MainHUDRoutine
org $8290F6		;When game is paused
	JSL MainHUDRoutine
	
org $90AAB5			;Blank HUDMap palette row 1
	DW !PaletteLine
org $90AADC			;Blank HUDMap palette row 2
	DW !PaletteLine
org $90AB19			;Blank HUDMap palette row 3
	DW !PaletteLine
org $90AAC5			;Explored HUDMap palette row 1
	DW !PaletteLine
org $90AAEC			;Explored HUDMap palette row 2
	DW !PaletteLine
org $90AB29			;Explored HUDMap palette row 3
	DW !PaletteLine
org $90AB56			;Center HUDMap flash palette
	JSR HUDMapFlash
	
org $90AC5A			;These are just a bunch of hijacks to allow a more dynamic 2 byte word in place of a single value, which would otherwise crash the game.
	JSR HUDCheck
org $90BE82
	JSR HUDCheck
org $90BEB7
	JSR HUDCheck
org $90BECF
	JSR HUDCheck
org $90BF2D
	JSR HUDCheck
org $90BFA7
	JSR HUDCheck
org $90C04C
	JSR HUDCheck
org $90C099
	JSR HUDCheck
org $90C4B8
	JSR HUDCheck
org $90C519
	JSR HUDCheck
org $90C5F3
	JSR HUDCheck
org $90DD57
	JSR HUDCheck
org $90C4EC
	DW $0180
org $90FF00
HUDCheck:
	LDA $09D2 : AND #$000F : RTS
HUDMapFlash:
	AND #$E3FF : ORA #!SelectPalette : RTS

org $8488C2			;Handles the beam pickup selections
	JSL Pickup : BRA $0E
org $82B068			;Handles beam selection on the equip screen
	JML BeamSelect
